﻿
Partial Class RSSReader_VB
    Inherits System.Web.UI.Page

    Protected Sub RSSReader_VB_Init(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Init

        Dim feedXML As XDocument = XDocument.Load(Server.MapPath("Feeds.xml"))

        Dim feeds = From feed In feedXML.Descendants("Feed") _
                    Where (feed.Attribute("status") Is Nothing) OrElse (feed.Attribute("status").Value <> "disabled") _
                    Select Name = feed.Element("Name").Value, Url = feed.Element("Url").Value

        FeedList.DataSource = feeds
        FeedList.DataBind()

    End Sub


    Protected Sub ReadBtn_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ReadBtn.Click

        Dim SlashNamespace As XNamespace = "http://purl.org/rss/1.0/modules/slash/"

        Dim rssFeed As XDocument = XDocument.Load(FeedList.SelectedValue)

        Dim posts = From item In rssFeed.Descendants("item") _
                    Select Title = item.Element("title").Value, _
                           Published = DateTime.Parse(item.Element("pubDate").Value), _
                           NumComments = Convert.ToInt32(item.Element(SlashNamespace + "comments").Value), _
                           Url = item.Element("link").Value, _
                           Tags = (From category In item.Elements("category") _
                                  Order By category.Value _
                                  Select category.Value).ToList()

        ListView1.DataSource = posts
        ListView1.DataBind()

    End Sub

End Class
